<template>
  <q-dialog v-if="registerDialog" v-model="visible" persistent>
    <q-card style="min-width: 350px; overflow-y: visible">
      <q-card-section>
        <div class="text-h6">Rejestracja</div>
      </q-card-section>

      <q-card-section class="q-pt-none">
        <!-- <q-input dense v-model="login" autofocus @keyup.enter="" />
        <q-input dense v-model="password" autofocus @keyup.enter="" /> -->
        <q-input label="email" dense v-model="login" type="text" autofocus />
        <q-input label="nick" dense v-model="nick" type="text" autofocus />
        <q-input
          label="hasło"
          dense
          v-model="password"
          type="password"
          autofocus
        />
        <ProgressBar :color="metterColor" :value="metterValue" />
        <q-input
          label="powtórz hasło"
          dense
          v-model="repeatPassword"
          type="password"
          autofocus
        />
        <!-- <q-input label="miejscowość" dense v-model="city" type="text" autofocus /> -->
        <AutocompleteCity @city="setCity" />
        <q-uploader
          ref="uploader"
          url="http://localhost:4444/upload"
          color="teal"
          flat
          bordered
          style="max-width: 300px"
        />
      </q-card-section>

      <q-card-actions align="right" class="text-primary">
        <q-btn flat label="Powrót" @click="toggleRegister" />
        <q-btn flat label="Rejestruj" @click="submit" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';
import { useRouter } from 'vue-router';
import { useQuasar } from 'quasar';

import { QUploader } from 'quasar';

import City from '../interfaces/City';
import { PasswordMeter } from 'password-meter';

import { api } from '../boot/axios';
import ProgressBar from './ProgressBar.vue';

import AutocompleteCity from './AutocompleteCity.vue';

defineOptions({
  name: 'RegisterDialog',
});

const $q = useQuasar();
const router = useRouter();
const uploader = ref<InstanceType<typeof QUploader> | null>(null);
const metter = new PasswordMeter();

export interface RegisterDialogProps {
  registerDialog: boolean;
  toggleRegister: () => void;
}

const props = withDefaults(defineProps<RegisterDialogProps>(), {
  registerDialog: false,
});
const login = ref<string>('');
const nick = ref<string>('');
const password = ref<string>('');
// const progress = ref(20.0);
const repeatPassword = ref<string>('');
// const city = ref<string>('');
const city = ref<City | null>(null);
const visible = ref<boolean>(true);
const metterValue = ref<number>(0);
const metterColor = ref<string>('');
const passwordComplexity = ref<boolean>(false);
const errors = ref<string[]>([]);
const base64 = ref<string>('');
function submit() {
  errors.value = [];
  if (login.value.length === 0) {
    errors.value.push('Email nie może być pusty');
  }
  if (!/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(login.value)) {
    errors.value.push('Email musi być poprawny');
  }
  if (nick.value.length === 0) {
    errors.value.push('Nick nie może być pusty');
  }
  if (password.value !== repeatPassword.value) {
    errors.value.push('Hasła się nie zgadzają');
  }
  if (!passwordComplexity.value) {
    errors.value.push('Hasło musi być wystarczająco złożone');
  }

  for (let i = 0, max = errors.value.length; i < max; i++) {
    $q.notify({
      message: errors.value[i],
      color: 'red',
      timeout: 6000,
    });
  }
  visible.value = true;
  if (errors.value.length > 0) {
    return;
  }

  if (uploader.value) {
    const reader = new FileReader();
    reader.readAsDataURL(uploader.value.files[0]);
    reader.onload = () => {
      if (typeof reader.result === 'string') {
        base64.value = reader.result;
        api
          .post('/user/register', {
            email: login.value,
            nick: nick.value,
            password: password.value,
            city: city.value,
            profileImage: base64.value,
          })
          .then(({ data }) => {
            const { status, message } = data;
            if (status === 'OK') {
              $q.notify({
                message: 'Zostałeś zarejestrowany',
                color: 'green',
                timeout: 6000,
              });

              setTimeout(() => {
                router.push('/');
                props.toggleRegister();
              }, 10000);
            }
            if (status === 'NOT OK' && message === 'user exists') {
              $q.notify({
                message: 'Wybrany użytkownik jest już zarejestrowany',
                color: 'red',
                timeout: 6000,
              });
            }

            if (status == 'NOT OK' && message == 'Profile image too large') {
              $q.notify({
                message:
                  'Dopuszczalna wielkość zdjęcia profilowego to 15MB. Spróbuj je skadrować lub/i skompresować',
                color: 'red',
                timeout: 6000,
              });
            }
          });
      }
    };

    console.log(uploader.value.files[0]);
  }
}
function setCity(cityObject: City) {
  city.value = cityObject;
}

watch(password, (newValue) => {
  const result = metter.getResult(newValue);
  metterValue.value = result.percent;
  console.log(result);
  switch (result.status) {
    case 'veryWeak':
      metterColor.value = '#B71C1C';
      passwordComplexity.value = false;
      break;
    case 'weak':
      metterColor.value = '#e65100';
      passwordComplexity.value = false;
      break;
    case 'medium':
      metterColor.value = '#f57f17';
      passwordComplexity.value = false;
      break;
    case 'strong':
      metterColor.value = '#33691e';
      passwordComplexity.value = true;
      break;
    case 'perfect':
      metterColor.value = '#33691e';
      passwordComplexity.value = true;
      break;
  }
});
</script>
